/* OS2INSTL.CMD - CREATE J Street Mailer OS/2 PROGRAM OBJECT ON DESKTOP 
   Copyright 1998, Charles H. McKinnis
   All rights granted to Innoval Systems Solutions, Inc. */
Trace('N')

/* check for OBJREXX */
Parse Version objrexx .
If objrexx = 'OBJREXX' Then orexx = 1
Else orexx = 0

/* load REXXUTIL functions */
Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
Call SysLoadFuncs

Parse Upper Source . . our_name .
our_drive = Filespec('D', our_name)
our_path  = Filespec('P', our_name)
jstreet_class = our_drive || our_path || 'innoval.jar'
jgl_class = our_drive || our_path || 'jgl.zip'
jbcl_class = our_drive || our_path || 'jbcl.zip'

rc = SysFileTree(jstreet_class, 'class.', 'FO')
If rc <> 0 | class.1 <> jstreet_class Then Do
   Say our_name 'must run from the same directory as innoval.jar.'
   Call Exit
End

rc = SysFileTree(jgl_class, 'class.', 'FO')
If rc = 0 & class.1 = jgl_class Then jgl = 1
Else jgl = 0

rc = SysFileTree(jbcl_class, 'class.', 'FO')
If rc = 0 & class.1 = jbcl_class Then jbcl = 1
Else jbcl = 0

If orexx Then Do
   file_sys = SysFileSystemType(our_drive)
   If file_sys = 'HPFS' | file_sys = 'FAT' Then Say 'Found' our_drive || our_path 'on an' file_sys 'drive.'
   Else Do
      Say 'J Street Mailer needs to run from an HPFS or FAT drive.'
      Say 'Found' our_drive || our_path 'on a' file_sys 'drive.'
      Call Exit
   End
   boot_drive = SysBootDrive()
End
Else Do
   Say 'Unable to check the file system for J Street Mailer.'
   Say 'If' our_drive || our_path 'is on an HPFS drive,'
   Say 'enter "HPFS" or "FAT" to continue, or any other answer to quit.'
   Parse Upper Pull file_sys .
   If \Abbrev(file_sys, 'HPFS') & \Abbrev(file_sys, 'FAT') Then Call Exit
   boot_drive = Filespec('D', SysSearchPath('PATH', 'PMSHELL.EXE'))
End

iconfile = our_drive ||our_path || 'os2instl.ico'
startpath = Strip(our_drive || our_path, 'T', '\')
java_name = SysSearchPath('PATH', 'JAVA.EXE')
java_drive = Filespec('D', java_name)
java_path = Filespec('P', java_name)
java_base = Filespec('P', Strip(java_path, 'T', '\'))
java_class = 'classes.zip'
rc = SysFileTree(java_drive || java_base || java_class, 'class.', 'FSO')
If rc = 0 & class.0 > 0 Then Do
   java_class = class.1
   Say 'Using JAVA class -' class.1
   Say 'Using JSTREET class -' jstreet_class
End
Else Do
   Say java_class 'not found under' java_base
   Call Exit
End
config = boot_drive || '\CONFIG.SYS'
rc = SysFileSearch('SET CLASSPATH=', config, 'cp.')
If rc = 0 & cp.0 > 0 Then Do i = 1 To cp.0
   testcp = Translate(cp.i)
   If Abbrev(testcp, 'REM') Then Iterate
   Else config_classpath = cp.i
End
Else Do
   Say 'Unable to locate SET CLASSPATH= in' config || '.'
   Call Exit
End

Say 'Do you want to use the Hot Java Browser (y,N)?'
Parse Upper Pull answer .
If Abbrev(answer, 'Y') Then hot_java = 1
Else hot_java = 0
If hot_java Then Do
   If file_sys = 'HPFS' Then hot_java_jar = our_drive || our_path || 'HotJavaBean.jar'
   Else Do
      'RENAME HotJavaBean.jar HOTJAVAB.JAR' 
      hot_java_jar = our_drive || our_path || 'HOTJAVAB.JAR'
   End
End

classpath = ''
If Pos(java_class, config_classpath) = 0 Then classpath = java_class || '^;'
Else Say 'Found' java_class 'in' config 'CLASSPATH.'
If Pos(jstreet_class, config_classpath) = 0 Then classpath = classpath || jstreet_class || '^;'
Else Say 'Found' jstreet_class 'in' config 'CLASSPATH.'
If jgl Then Do
   If Pos(jgl_class, config_classpath) = 0 Then classpath = classpath || jgl_class || '^;'
   Else Say 'Found' jgl_class 'in' config 'CLASSPATH.'
End
If jbcl Then Do
   If Pos(jbcl_class, config_classpath) = 0 Then classpath = classpath || jbcl_class || '^;'
   Else Say 'Found' jbcl_class 'in' config 'CLASSPATH.'
End
If hot_java Then Do
   If Pos(hot_java_jar, config_classpath) = 0 Then classpath = classpath || hot_java_jar || '^;'
   Else Say 'Found' hot_java_jar 'in' config 'CLASSPATH.'
End
If classpath <> '' Then classpath = '-classpath' classpath

parameters = ''
jstreet_name = 'innoval.mailer.jstreet'
If classpath <> '' Then parameters = classpath jstreet_name
Else parameters = jstreet_name
Say 'Do you want to disable the JIT compiler (y,N)?'
Parse Upper Pull answer .
If Abbrev(answer, 'Y') Then parameters = '-Djava.compiler=xxx' parameters

class = 'WPProgram'
title = 'J Street^Mailer'
location = '<WP_DESKTOP>'
obj = 'OBJECTID=<J_Street_Mailer>;'
exec = 'EXENAME=' || java_name || ';'
parm = 'PARAMETERS=' || parameters || ';'
startdir = 'STARTUPDIR=' || startpath || ';'
window = 'PROGTYPE=WINDOWABLEVIO;CCVIEW=NO;'
Say 'Do you want to run with the Java console window minimized (Y,n)?'
Parse Upper Pull answer .
If Abbrev(answer, 'N') Then window = window || 'MINIMIZED=NO;'
Else window = window || 'MINIMIZED=YES;'
Say 'Do you want to close the Java window when J Street ends (Y,n)?'
Parse Upper Pull answer .
If Abbrev(answer, 'N') Then window = window || 'NOAUTOCLOSE=YES;'
icon = 'ICONFILE=' || iconfile || ';ICONPOS=45 45;'
setup = obj || exec || parm || startdir || window || icon
If SysCreateObject(class, title, location, setup, 'U') Then
   Say 'J Street Mailer program created or updated.'
Else Say 'Failed to create or update J Street Mailer program.'
Call Exit

Exit:
   Procedure
   Call SysDropFuncs
   Exit
Return
